<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - lcov.info - lib/api_client.dart</title>
  <link rel="stylesheet" type="text/css" href="../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../index.html">top level</a> - <a href="index.html">lib</a> - api_client.dart<span style="font-size: 80%;"> (source / <a href="api_client.dart.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">lcov.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">30</td>
            <td class="headerCovTableEntry">64</td>
            <td class="headerCovTableEntryLo">46.9 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2021-02-04 11:27:27</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">0</td>
            <td class="headerCovTableEntry">0</td>
            <td class="headerCovTableEntryHi">-</td>
          </tr>
          <tr><td><img src="../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span>            : import 'dart:convert';</a>
<a name="2"><span class="lineNum">       2 </span>            : import 'package:fr_geo_gouv_api/fr_geo_gouv_api.dart';</a>
<a name="3"><span class="lineNum">       3 </span>            : import 'package:fr_geo_gouv_api/models/feature_collection.dart';</a>
<a name="4"><span class="lineNum">       4 </span>            : import 'package:http/http.dart';</a>
<a name="5"><span class="lineNum">       5 </span>            : </a>
<a name="6"><span class="lineNum">       6 </span>            : class QueryParam {</a>
<a name="7"><span class="lineNum">       7 </span>            :   String name;</a>
<a name="8"><span class="lineNum">       8 </span>            :   String value;</a>
<a name="9"><span class="lineNum">       9 </span>            : </a>
<a name="10"><span class="lineNum">      10 </span><span class="lineCov">          1 :   QueryParam(this.name, this.value);</span></a>
<a name="11"><span class="lineNum">      11 </span>            : }</a>
<a name="12"><span class="lineNum">      12 </span>            : </a>
<a name="13"><span class="lineNum">      13 </span>            : class ApiClient {</a>
<a name="14"><span class="lineNum">      14 </span>            :   String basePath;</a>
<a name="15"><span class="lineNum">      15 </span>            :   var client = Client();</a>
<a name="16"><span class="lineNum">      16 </span>            : </a>
<a name="17"><span class="lineNum">      17 </span>            :   Map&lt;String, String&gt; _defaultHeaderMap = {};</a>
<a name="18"><span class="lineNum">      18 </span>            : </a>
<a name="19"><span class="lineNum">      19 </span>            :   final _regList = RegExp(r'^List&lt;(.*)&gt;$');</a>
<a name="20"><span class="lineNum">      20 </span>            :   final _regMap = RegExp(r'^Map&lt;String,(.*)&gt;$');</a>
<a name="21"><span class="lineNum">      21 </span>            : </a>
<a name="22"><span class="lineNum">      22 </span><span class="lineCov">          1 :   ApiClient({this.basePath = &quot;https://api-adresse.data.gouv.fr/&quot;}) {</span></a>
<a name="23"><span class="lineNum">      23 </span>            :     // Setup authentications (key: authentication name, value: authentication).</a>
<a name="24"><span class="lineNum">      24 </span>            :     // _authentications['ApiKeyAuth'] = ApiKeyAuth(&quot;header&quot;, &quot;x-access-token&quot;);</a>
<a name="25"><span class="lineNum">      25 </span>            :   }</a>
<a name="26"><span class="lineNum">      26 </span>            : </a>
<a name="27"><span class="lineNum">      27 </span><span class="lineNoCov">          0 :   void addDefaultHeader(String key, String value) {</span></a>
<a name="28"><span class="lineNum">      28 </span><span class="lineNoCov">          0 :     _defaultHeaderMap[key] = value;</span></a>
<a name="29"><span class="lineNum">      29 </span>            :   }</a>
<a name="30"><span class="lineNum">      30 </span>            : </a>
<a name="31"><span class="lineNum">      31 </span><span class="lineCov">          1 :   dynamic _deserialize(dynamic value, String targetType) {</span></a>
<a name="32"><span class="lineNum">      32 </span>            :     try {</a>
<a name="33"><span class="lineNum">      33 </span>            :       switch (targetType) {</a>
<a name="34"><span class="lineNum">      34 </span><span class="lineCov">          1 :         case 'String':</span></a>
<a name="35"><span class="lineNum">      35 </span><span class="lineNoCov">          0 :           return '$value';</span></a>
<a name="36"><span class="lineNum">      36 </span><span class="lineCov">          1 :         case 'int':</span></a>
<a name="37"><span class="lineNum">      37 </span><span class="lineNoCov">          0 :           return value is int ? value : int.parse('$value');</span></a>
<a name="38"><span class="lineNum">      38 </span><span class="lineCov">          1 :         case 'bool':</span></a>
<a name="39"><span class="lineNum">      39 </span><span class="lineNoCov">          0 :           return value is bool ? value : '$value'.toLowerCase() == 'true';</span></a>
<a name="40"><span class="lineNum">      40 </span><span class="lineCov">          1 :         case 'double':</span></a>
<a name="41"><span class="lineNum">      41 </span><span class="lineNoCov">          0 :           return value is double ? value : double.parse('$value');</span></a>
<a name="42"><span class="lineNum">      42 </span><span class="lineCov">          1 :         case 'FeatureCollection':</span></a>
<a name="43"><span class="lineNum">      43 </span><span class="lineCov">          1 :           return FeatureCollection.fromMap(value);</span></a>
<a name="44"><span class="lineNum">      44 </span><span class="lineNoCov">          0 :         case 'Feature':</span></a>
<a name="45"><span class="lineNum">      45 </span><span class="lineNoCov">          0 :           return Feature.fromMap(value);</span></a>
<a name="46"><span class="lineNum">      46 </span><span class="lineNoCov">          0 :         case 'Geometry':</span></a>
<a name="47"><span class="lineNum">      47 </span><span class="lineNoCov">          0 :           return Geometry.fromMap(value);</span></a>
<a name="48"><span class="lineNum">      48 </span><span class="lineNoCov">          0 :         case 'Properties':</span></a>
<a name="49"><span class="lineNum">      49 </span><span class="lineNoCov">          0 :           return Properties.fromMap(value);</span></a>
<a name="50"><span class="lineNum">      50 </span>            :         default:</a>
<a name="51"><span class="lineNum">      51 </span>            :           {</a>
<a name="52"><span class="lineNum">      52 </span>            :             Match match;</a>
<a name="53"><span class="lineNum">      53 </span><span class="lineNoCov">          0 :             if (value is List &amp;&amp; (match = _regList.firstMatch(targetType)) != null) {</span></a>
<a name="54"><span class="lineNum">      54 </span><span class="lineNoCov">          0 :               var newTargetType = match[1];</span></a>
<a name="55"><span class="lineNum">      55 </span><span class="lineNoCov">          0 :               return value.map((v) =&gt; _deserialize(v, newTargetType)).toList();</span></a>
<a name="56"><span class="lineNum">      56 </span><span class="lineNoCov">          0 :             } else if (value is Map &amp;&amp; (match = _regMap.firstMatch(targetType)) != null) {</span></a>
<a name="57"><span class="lineNum">      57 </span><span class="lineNoCov">          0 :               var newTargetType = match[1];</span></a>
<a name="58"><span class="lineNum">      58 </span><span class="lineNoCov">          0 :               return Map.fromIterables(value.keys, value.values.map((v) =&gt; _deserialize(v, newTargetType)));</span></a>
<a name="59"><span class="lineNum">      59 </span>            :             }</a>
<a name="60"><span class="lineNum">      60 </span>            :           }</a>
<a name="61"><span class="lineNum">      61 </span>            :       }</a>
<a name="62"><span class="lineNum">      62 </span><span class="lineNoCov">          0 :     } on Exception catch (e, stack) {</span></a>
<a name="63"><span class="lineNum">      63 </span><span class="lineNoCov">          0 :       throw ApiException.withInner(500, 'Exception during deserialization.', e, stack);</span></a>
<a name="64"><span class="lineNum">      64 </span>            :     }</a>
<a name="65"><span class="lineNum">      65 </span><span class="lineNoCov">          0 :     throw ApiException(500, 'Could not find a suitable class for deserialization');</span></a>
<a name="66"><span class="lineNum">      66 </span>            :   }</a>
<a name="67"><span class="lineNum">      67 </span>            : </a>
<a name="68"><span class="lineNum">      68 </span><span class="lineCov">          1 :   dynamic deserialize(String json, String targetType) {</span></a>
<a name="69"><span class="lineNum">      69 </span>            :     // Remove all spaces.  Necessary for reg expressions as well.</a>
<a name="70"><span class="lineNum">      70 </span><span class="lineCov">          1 :     targetType = targetType.replaceAll(' ', '');</span></a>
<a name="71"><span class="lineNum">      71 </span>            : </a>
<a name="72"><span class="lineNum">      72 </span><span class="lineCov">          1 :     if (targetType == 'String') return json;</span></a>
<a name="73"><span class="lineNum">      73 </span>            : </a>
<a name="74"><span class="lineNum">      74 </span><span class="lineCov">          1 :     var decodedJson = jsonDecode(json);</span></a>
<a name="75"><span class="lineNum">      75 </span><span class="lineCov">          1 :     return _deserialize(decodedJson, targetType);</span></a>
<a name="76"><span class="lineNum">      76 </span>            :   }</a>
<a name="77"><span class="lineNum">      77 </span>            : </a>
<a name="78"><span class="lineNum">      78 </span><span class="lineCov">          1 :   String serialize(Object obj) {</span></a>
<a name="79"><span class="lineNum">      79 </span>            :     String serialized = '';</a>
<a name="80"><span class="lineNum">      80 </span>            :     if (obj == null) {</a>
<a name="81"><span class="lineNum">      81 </span>            :       serialized = '';</a>
<a name="82"><span class="lineNum">      82 </span>            :     } else {</a>
<a name="83"><span class="lineNum">      83 </span><span class="lineNoCov">          0 :       serialized = json.encode(obj);</span></a>
<a name="84"><span class="lineNum">      84 </span>            :     }</a>
<a name="85"><span class="lineNum">      85 </span>            :     return serialized;</a>
<a name="86"><span class="lineNum">      86 </span>            :   }</a>
<a name="87"><span class="lineNum">      87 </span>            : </a>
<a name="88"><span class="lineNum">      88 </span>            :   // We don't use a Map&lt;String, String&gt; for queryParams.</a>
<a name="89"><span class="lineNum">      89 </span>            :   // If collectionFormat is 'multi' a key might appear multiple times.</a>
<a name="90"><span class="lineNum">      90 </span><span class="lineCov">          1 :   Future&lt;Response&gt; invokeAPI(String path, String method, List&lt;QueryParam&gt; queryParams, Object body, Map&lt;String, String&gt; headerParams,</span></a>
<a name="91"><span class="lineNum">      91 </span>            :       Map&lt;String, String&gt; formParams, String nullableContentType, List&lt;String&gt; authNames) async {</a>
<a name="92"><span class="lineNum">      92 </span>            :     // _updateParamsForAuth(authNames, queryParams, headerParams);</a>
<a name="93"><span class="lineNum">      93 </span>            : </a>
<a name="94"><span class="lineNum">      94 </span><span class="lineCov">          9 :     var ps = queryParams.where((p) =&gt; p.value != null).map((p) =&gt; '${p.name}=${Uri.encodeQueryComponent(p.value)}');</span></a>
<a name="95"><span class="lineNum">      95 </span>            : </a>
<a name="96"><span class="lineNum">      96 </span><span class="lineCov">          3 :     String queryString = ps.isNotEmpty ? '?' + ps.join('&amp;') : '';</span></a>
<a name="97"><span class="lineNum">      97 </span>            : </a>
<a name="98"><span class="lineNum">      98 </span><span class="lineCov">          3 :     String url = basePath + path + queryString;</span></a>
<a name="99"><span class="lineNum">      99 </span>            : </a>
<a name="100"><span class="lineNum">     100 </span><span class="lineCov">          2 :     headerParams.addAll(_defaultHeaderMap);</span></a>
<a name="101"><span class="lineNum">     101 </span>            :     if (nullableContentType != null) {</a>
<a name="102"><span class="lineNum">     102 </span>            :       final contentType = nullableContentType;</a>
<a name="103"><span class="lineNum">     103 </span><span class="lineCov">          1 :       headerParams['Content-Type'] = contentType;</span></a>
<a name="104"><span class="lineNum">     104 </span>            :     }</a>
<a name="105"><span class="lineNum">     105 </span>            : </a>
<a name="106"><span class="lineNum">     106 </span><span class="lineCov">          1 :     if (body is MultipartRequest) {</span></a>
<a name="107"><span class="lineNum">     107 </span><span class="lineNoCov">          0 :       var request = MultipartRequest(method, Uri.parse(url));</span></a>
<a name="108"><span class="lineNum">     108 </span><span class="lineNoCov">          0 :       request.fields.addAll(body.fields);</span></a>
<a name="109"><span class="lineNum">     109 </span><span class="lineNoCov">          0 :       request.files.addAll(body.files);</span></a>
<a name="110"><span class="lineNum">     110 </span><span class="lineNoCov">          0 :       request.headers.addAll(body.headers);</span></a>
<a name="111"><span class="lineNum">     111 </span><span class="lineNoCov">          0 :       request.headers.addAll(headerParams);</span></a>
<a name="112"><span class="lineNum">     112 </span><span class="lineNoCov">          0 :       var response = await client.send(request);</span></a>
<a name="113"><span class="lineNum">     113 </span><span class="lineNoCov">          0 :       return Response.fromStream(response);</span></a>
<a name="114"><span class="lineNum">     114 </span>            :     } else {</a>
<a name="115"><span class="lineNum">     115 </span><span class="lineCov">          2 :       var msgBody = nullableContentType == &quot;application/x-www-form-urlencoded&quot; ? formParams : serialize(body);</span></a>
<a name="116"><span class="lineNum">     116 </span><span class="lineCov">          1 :       final nullableHeaderParams = (headerParams.isEmpty) ? null : headerParams;</span></a>
<a name="117"><span class="lineNum">     117 </span>            :       switch (method) {</a>
<a name="118"><span class="lineNum">     118 </span><span class="lineCov">          1 :         case &quot;POST&quot;:</span></a>
<a name="119"><span class="lineNum">     119 </span><span class="lineNoCov">          0 :           return client.post(url, headers: nullableHeaderParams, body: msgBody);</span></a>
<a name="120"><span class="lineNum">     120 </span><span class="lineCov">          1 :         case &quot;PUT&quot;:</span></a>
<a name="121"><span class="lineNum">     121 </span><span class="lineNoCov">          0 :           return client.put(url, headers: nullableHeaderParams, body: msgBody);</span></a>
<a name="122"><span class="lineNum">     122 </span><span class="lineCov">          1 :         case &quot;DELETE&quot;:</span></a>
<a name="123"><span class="lineNum">     123 </span><span class="lineNoCov">          0 :           return client.delete(url, headers: nullableHeaderParams);</span></a>
<a name="124"><span class="lineNum">     124 </span><span class="lineCov">          1 :         case &quot;PATCH&quot;:</span></a>
<a name="125"><span class="lineNum">     125 </span><span class="lineNoCov">          0 :           return client.patch(url, headers: nullableHeaderParams, body: msgBody);</span></a>
<a name="126"><span class="lineNum">     126 </span><span class="lineCov">          1 :         case &quot;HEAD&quot;:</span></a>
<a name="127"><span class="lineNum">     127 </span><span class="lineNoCov">          0 :           return client.head(url, headers: nullableHeaderParams);</span></a>
<a name="128"><span class="lineNum">     128 </span>            :         default:</a>
<a name="129"><span class="lineNum">     129 </span><span class="lineCov">          2 :           return client.get(url, headers: nullableHeaderParams);</span></a>
<a name="130"><span class="lineNum">     130 </span>            :       }</a>
<a name="131"><span class="lineNum">     131 </span>            :     }</a>
<a name="132"><span class="lineNum">     132 </span>            :   }</a>
<a name="133"><span class="lineNum">     133 </span>            : }</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.15</a></td></tr>
  </table>
  <br>

</body>
</html>
